package beilv.usermembershipcard.service;

import beilv.usermembershipcard.domain.MemberStream;
import beilv.usermembershipcard.domain.UserMembershipCard;

import java.util.List;
import java.util.Map;

/**
 * 用户会员卡Service接口
 *
 * @author ruoyi
 * @date 2025-01-02
 */
public interface IUserMembershipCardService {
    /**
     * 查询用户会员卡
     *
     * @param id 用户会员卡主键
     * @return 用户会员卡
     */
    public UserMembershipCard selectUserMembershipCardById(Long id);

    /**
     * 查询用户会员卡列表
     *
     * @param userMembershipCard 用户会员卡
     * @return 用户会员卡集合
     */
    public List<UserMembershipCard> selectUserMembershipCardList(UserMembershipCard userMembershipCard);

    /**
     * 新增用户会员卡
     *
     * @param userMembershipCard 用户会员卡
     * @return 结果
     */
    public int insertUserMembershipCard(UserMembershipCard userMembershipCard);

    /**
     * 修改用户会员卡
     *
     * @param userMembershipCard 用户会员卡
     * @return 结果
     */
    public int updateUserMembershipCard(UserMembershipCard userMembershipCard);

    /**
     * 批量删除用户会员卡
     *
     * @param ids 需要删除的用户会员卡主键集合
     * @return 结果
     */
    public int deleteUserMembershipCardByIds(String ids);

    /**
     * 删除用户会员卡信息
     *
     * @param id 用户会员卡主键
     * @return 结果
     */
    public int deleteUserMembershipCardById(Long id);

    /*
    * 查看流水列表
    *
    * @author 韩福成
    * @date 2025/1/8 上午9:23
    */
    public List<Map<String,Object>> getStream(Long id);

    /*
    * 增加会员卡流水
    *
    * @author 韩福成
    * @date 2025/1/8 上午9:23
    */
    public int addStream(MemberStream memberStream);

    /*
     * 新增退卡记录
     *
     * @author 韩福成
     * @date 2025/1/7 上午10:47
     */
    public int refundCard(UserMembershipCard userMembershipCard);

    UserMembershipCard selectUserMembershipCardRecordId(String id);
}
